Index: trunk/NEMO/OPA_SRC/SOL/solmat.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SOL/solmat.F90	(revision 1598)
+++ trunk/NEMO/OPA_SRC/SOL/solmat.F90	(revision 1601)
@@ -4,23 +4,21 @@
    !! solver       : construction of the matrix 
    !!======================================================================
-   !! History :   1.0  !  88-04  (G. Madec)  Original code
-   !!                  !  93-03  (M. Guyon)  symetrical conditions
-   !!                  !  93-06  (M. Guyon)  suppress pointers
-   !!                  !  96-05  (G. Madec)  merge sor and pcg formulations
-   !!                  !  96-11  (A. Weaver)  correction to preconditioning
-   !!             8.5  !  02-08  (G. Madec)  F90: Free form
-   !!                  !  02-11  (C. Talandier, A-M. Treguier) Free surface & Open boundaries
-   !!             9.0  !  05-09  (R. Benshila)  add sol_exd for extra outer halo
-   !!             9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
-   !!             9.0  !  06-07  (S. Masson)  distributed restart using iom
-   !!----------------------------------------------------------------------
-
-   !!----------------------------------------------------------------------
-   !!   sol_mat       : Construction of the matrix of used by the elliptic solvers
-   !!   fetsch        :
-   !!   fetmat        :
-   !!   fetstr        :
-   !!----------------------------------------------------------------------
-   !! * Modules used
+   !! History :   1.0  ! 1988-04  (G. Madec)  Original code
+   !!                  ! 1993-03  (M. Guyon)  symetrical conditions
+   !!                  ! 1993-06  (M. Guyon)  suppress pointers
+   !!                  ! 1996-05  (G. Madec)  merge sor and pcg formulations
+   !!                  ! 1996-11  (A. Weaver)  correction to preconditioning
+   !!   NEMO      1.0  ! 1902-08  (G. Madec)  F90: Free form
+   !!              -   ! 1902-11  (C. Talandier, A-M. Treguier) Free surface & Open boundaries
+   !!             2.0  ! 2005-09  (R. Benshila)  add sol_exd for extra outer halo
+   !!              -   ! 2005-11  (V. Garnier) Surface pressure gradient organization
+   !!             3.2  ! 2009-06  (S. Masson)  distributed restart using iom
+   !!              -   ! 2009-07  (R. Benshila)  suppression of rigid-lid option
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   sol_mat : Construction of the matrix of used by the elliptic solvers
+   !!   sol_exd :
+   !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
@@ -35,8 +33,8 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC sol_mat     ! routine called by inisol.F90
-   !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   PUBLIC   sol_mat    ! routine called by inisol.F90
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
@@ -50,10 +48,8 @@
       !!
       !! ** Purpose :   Construction of the matrix of used by the elliptic 
-      !!      solvers (either sor or pcg methods).
-      !!
-      !! ** Method  :  
-      !!      lk_dynspg_flt=T: free surface formulation
-      !!      The matrix is built for the divergence of the transport system
-      !!      a diagonal preconditioning matrix is also defined.
+      !!              solvers (either sor or pcg methods).
+      !!
+      !! ** Method  :   The matrix is built for the divergence of the transport 
+      !!              system. a diagonal preconditioning matrix is also defined.
       !! 
       !! ** Action  : - gcp    : extra-diagonal elements of the matrix
@@ -61,8 +57,6 @@
       !!              - gcdprc : inverse of the preconditioning matrix
       !!----------------------------------------------------------------------
-      !! * Arguments
       INTEGER, INTENT(in) :: kt
-
-      !! * Local declarations
+      !!
       INTEGER ::   ji, jj                    ! dummy loop indices
       REAL(wp) ::   zcoefs, zcoefw, zcoefe, zcoefn  ! temporary scalars
@@ -73,29 +67,22 @@
       ! 1. Construction of the matrix
       ! -----------------------------
-      
-      ! initialize to zero
-      zcoef = 0.e0
+      zcoef = 0.e0                          ! initialize to zero
       gcp(:,:,1) = 0.e0
       gcp(:,:,2) = 0.e0
       gcp(:,:,3) = 0.e0
       gcp(:,:,4) = 0.e0
-      
+      !
       gcdprc(:,:) = 0.e0
       gcdmat(:,:) = 0.e0
-      
-      IF( neuler == 0 .AND. kt == nit000 ) THEN
-         z2dt = rdt
-      ELSE
-         z2dt = 2. * rdt
+      !
+      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;   z2dt = rdt
+      ELSE                                        ;   z2dt = 2. * rdt
       ENDIF
 
 #if defined key_dynspg_flt && ! defined key_obc
-!!cr      IF( lk_dynspg_flt .AND. .NOT.lk_obc ) THEN   !bug missing lk_dynspg_flt_atsk
-
-      ! defined the coefficients for free surface elliptic system
-
-      DO jj = 2, jpjm1
+
+      DO jj = 2, jpjm1                      ! matrix of free surface elliptic system
          DO ji = 2, jpim1
-            zcoef = z2dt * z2dt * grav * rnu * bmask(ji,jj)
+            zcoef = z2dt * z2dt * grav * bmask(ji,jj)
             zcoefs = -zcoef * hv(ji  ,jj-1) * e1v(ji  ,jj-1) / e2v(ji  ,jj-1)    ! south coefficient
             zcoefw = -zcoef * hu(ji-1,jj  ) * e2u(ji-1,jj  ) / e1u(ji-1,jj  )    ! west coefficient
@@ -112,12 +99,9 @@
       
 #  elif defined key_dynspg_flt && defined key_obc
-!!cr      ELSEIF( lk_dynspg_flt .AND. lk_obc ) THEN     !bug missing lk_dynspg_flt_atsk 
-
-      !   defined gcdmat in the case of open boundaries
-
-      DO jj = 2, jpjm1
+
+      DO jj = 2, jpjm1                      ! matrix of free surface elliptic system with open boundaries
          DO ji = 2, jpim1
-            zcoef = z2dt * z2dt * grav * rnu * bmask(ji,jj)
-            !  south coefficient
+            zcoef = z2dt * z2dt * grav * bmask(ji,jj)
+            !                                    ! south coefficient
             IF( lp_obc_south .AND. ( jj == njs0p1 ) ) THEN
                zcoefs = -zcoef * hv(ji,jj-1) * e1v(ji,jj-1)/e2v(ji,jj-1)*(1.-vsmsk(ji,1))
@@ -126,6 +110,6 @@
             END IF
             gcp(ji,jj,1) = zcoefs
-
-            !  west coefficient
+            !
+            !                                    ! west coefficient
             IF( lp_obc_west  .AND. ( ji == niw0p1 ) ) THEN
                zcoefw = -zcoef * hu(ji-1,jj) * e2u(ji-1,jj)/e1u(ji-1,jj)*(1.-uwmsk(jj,1))
@@ -134,6 +118,6 @@
             END IF
             gcp(ji,jj,2) = zcoefw
-
-            !   east coefficient
+            !
+            !                                    ! east coefficient
             IF( lp_obc_east  .AND. ( ji == nie0 ) ) THEN
                zcoefe = -zcoef * hu(ji,jj) * e2u(ji,jj)/e1u(ji,jj)*(1.-uemsk(jj,1))
@@ -142,6 +126,6 @@
             END IF
             gcp(ji,jj,3) = zcoefe
-
-            !   north coefficient
+            !
+            !                                    ! north coefficient
             IF( lp_obc_north .AND. ( jj == njn0 ) ) THEN
                zcoefn = -zcoef * hv(ji,jj) * e1v(ji,jj)/e2v(ji,jj)*(1.-vnmsk(ji,1))
@@ -150,82 +134,62 @@
             END IF
             gcp(ji,jj,4) = zcoefn
-
-            ! diagonal coefficient
-            gcdmat(ji,jj) = e1t(ji,jj)*e2t(ji,jj)*bmask(ji,jj) &
-                            - zcoefs -zcoefw -zcoefe -zcoefn
+            !
+            !                                    ! diagonal coefficient
+            gcdmat(ji,jj) = e1t(ji,jj)*e2t(ji,jj)*bmask(ji,jj)   &
+               &            - zcoefs -zcoefw -zcoefe -zcoefn
          END DO
       END DO
-
-#  else
-!!cr      ELSE
-
-      !   defined the coefficients for bsf elliptic system
-      
-      DO jj = 2, jpjm1
-         DO ji = 2, jpim1
-            zcoefs = -hur(ji  ,jj  ) * e1u(ji  ,jj  ) / e2u(ji  ,jj  ) * bmask(ji,jj)   ! south coefficient
-            zcoefw = -hvr(ji  ,jj  ) * e2v(ji  ,jj  ) / e1v(ji  ,jj  ) * bmask(ji,jj)   ! west coefficient
-            zcoefe = -hvr(ji+1,jj  ) * e2v(ji+1,jj  ) / e1v(ji+1,jj  ) * bmask(ji,jj)   ! east coefficient
-            zcoefn = -hur(ji  ,jj+1) * e1u(ji  ,jj+1) / e2u(ji  ,jj+1) * bmask(ji,jj)   ! north coefficient
-            gcp(ji,jj,1) = zcoefs
-            gcp(ji,jj,2) = zcoefw
-            gcp(ji,jj,3) = zcoefe
-            gcp(ji,jj,4) = zcoefn
-            gcdmat(ji,jj) = -zcoefs -zcoefw -zcoefe -zcoefn                             ! diagonal coefficient
+#endif
+
+#if defined key_agrif
+      IF( .NOT.AGRIF_ROOT() ) THEN
+         !
+         IF( nbondi == -1 .OR. nbondi == 2 )   bmask(2     ,:     ) = 0.e0
+         IF( nbondi ==  1 .OR. nbondi == 2 )   bmask(nlci-1,:     ) = 0.e0
+         IF( nbondj == -1 .OR. nbondj == 2 )   bmask(:     ,2     ) = 0.e0
+         IF( nbondj ==  1 .OR. nbondj == 2 )   bmask(:     ,nlcj-1) = 0.e0
+         !
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               zcoef = z2dt * z2dt * grav * bmask(ji,jj)
+               !  south coefficient
+               IF( ( nbondj == -1 .OR. nbondj == 2 ) .AND. ( jj == 3 ) ) THEN
+                  zcoefs = -zcoef * hv(ji,jj-1) * e1v(ji,jj-1)/e2v(ji,jj-1)*(1.-vmask(ji,jj-1,1))
+               ELSE
+                  zcoefs = -zcoef * hv(ji,jj-1) * e1v(ji,jj-1)/e2v(ji,jj-1)
+               END IF
+               gcp(ji,jj,1) = zcoefs
+               ! 
+               !  west coefficient
+               IF( ( nbondi == -1 .OR. nbondi == 2 ) .AND. ( ji == 3 )  ) THEN
+                  zcoefw = -zcoef * hu(ji-1,jj) * e2u(ji-1,jj)/e1u(ji-1,jj)*(1.-umask(ji-1,jj,1))
+               ELSE
+                  zcoefw = -zcoef * hu(ji-1,jj) * e2u(ji-1,jj)/e1u(ji-1,jj)
+               END IF
+               gcp(ji,jj,2) = zcoefw
+               !
+               !   east coefficient
+               IF( ( nbondi == 1 .OR. nbondi == 2 ) .AND. ( ji == nlci-2 ) ) THEN
+                  zcoefe = -zcoef * hu(ji,jj) * e2u(ji,jj)/e1u(ji,jj)*(1.-umask(ji,jj,1))
+               ELSE
+                  zcoefe = -zcoef * hu(ji,jj) * e2u(ji,jj)/e1u(ji,jj)
+               END IF
+               gcp(ji,jj,3) = zcoefe
+               !
+               !   north coefficient
+               IF( ( nbondj == 1 .OR. nbondj == 2 ) .AND. ( jj == nlcj-2 ) ) THEN
+                  zcoefn = -zcoef * hv(ji,jj) * e1v(ji,jj)/e2v(ji,jj)*(1.-vmask(ji,jj,1))
+               ELSE
+                  zcoefn = -zcoef * hv(ji,jj) * e1v(ji,jj)/e2v(ji,jj)
+               END IF
+               gcp(ji,jj,4) = zcoefn
+               !
+               ! diagonal coefficient
+               gcdmat(ji,jj) = e1t(ji,jj)*e2t(ji,jj)*bmask(ji,jj)   &
+                  &            - zcoefs -zcoefw -zcoefe -zcoefn
+            END DO
          END DO
-      END DO
-      
-!!cr  ENDIF
-#endif
-#if defined key_agrif
-       IF (.NOT.AGRIF_ROOT()) THEN
-       
-       IF ( (nbondi == -1)  .OR. (nbondi == 2) ) bmask(2,:)=0.
-       IF ( (nbondi ==  1)  .OR. (nbondi == 2) ) bmask(nlci-1,:)=0.
-       IF ( (nbondj == -1)  .OR. (nbondj == 2) ) bmask(:,2)=0.
-       IF ( (nbondj ==  1)  .OR. (nbondj == 2) ) bmask(:,nlcj-1)=0.
-
-      DO jj = 2, jpjm1
-         DO ji = 2, jpim1
-            zcoef = z2dt * z2dt * grav * rnu * bmask(ji,jj)
-            !  south coefficient
-            IF( ((nbondj == -1)  .OR. (nbondj == 2)) .AND. ( jj == 3 ) ) THEN
-               zcoefs = -zcoef * hv(ji,jj-1) * e1v(ji,jj-1)/e2v(ji,jj-1)*(1.-vmask(ji,jj-1,1))
-            ELSE
-               zcoefs = -zcoef * hv(ji,jj-1) * e1v(ji,jj-1)/e2v(ji,jj-1)
-            END IF
-            gcp(ji,jj,1) = zcoefs
-
-            !  west coefficient
-	    IF( ( (nbondi == -1)  .OR. (nbondi == 2) ) .AND. ( ji == 3 )  ) THEN
-               zcoefw = -zcoef * hu(ji-1,jj) * e2u(ji-1,jj)/e1u(ji-1,jj)*(1.-umask(ji-1,jj,1))
-            ELSE
-               zcoefw = -zcoef * hu(ji-1,jj) * e2u(ji-1,jj)/e1u(ji-1,jj)
-            END IF
-            gcp(ji,jj,2) = zcoefw
-
-            !   east coefficient
-            IF( ((nbondi == 1)  .OR. (nbondi == 2)) .AND. ( ji == nlci-2 ) ) THEN
-               zcoefe = -zcoef * hu(ji,jj) * e2u(ji,jj)/e1u(ji,jj)*(1.-umask(ji,jj,1))
-            ELSE
-               zcoefe = -zcoef * hu(ji,jj) * e2u(ji,jj)/e1u(ji,jj)
-            END IF
-            gcp(ji,jj,3) = zcoefe
-
-            !   north coefficient
-            IF( ((nbondj == 1)  .OR. (nbondj == 2)) .AND. ( jj == nlcj-2 ) ) THEN
-               zcoefn = -zcoef * hv(ji,jj) * e1v(ji,jj)/e2v(ji,jj)*(1.-vmask(ji,jj,1))
-            ELSE
-               zcoefn = -zcoef * hv(ji,jj) * e1v(ji,jj)/e2v(ji,jj)
-            END IF
-            gcp(ji,jj,4) = zcoefn
-
-            ! diagonal coefficient
-            gcdmat(ji,jj) = e1t(ji,jj)*e2t(ji,jj)*bmask(ji,jj) &
-                            - zcoefs -zcoefw -zcoefe -zcoefn
-         END DO
-      END DO
-      
-       ENDIF
+         ! 
+      ENDIF
 #endif
 
@@ -244,17 +208,4 @@
       ! the diagonal coefficient of the southern grid points must be modify to
       ! account for the existence of the south symmetric bassin.
-      
-!!cr      IF( .NOT.lk_dynspg_flt ) THEN   !bug missing lk_dynspg_flt_atsk
-#if ! defined key_dynspg_flt
-      IF( nperio == 2 ) THEN
-         DO ji = 1, jpi
-            IF( bmask(ji,2) /= 0.e0 ) THEN
-               zcoefs = - hur(ji,2)*e1u(ji,2)/e2u(ji,2)
-               gcdmat(ji,2) = gcdmat(ji,2) - zcoefs
-            ENDIF
-         END DO
-      ENDIF
-!!cr      ENDIF
-#endif
       
       ! North fold boundary condition
@@ -276,7 +227,7 @@
       gcp(:,:,3) = gcp(:,:,3) * gcdprc(:,:)
       gcp(:,:,4) = gcp(:,:,4) * gcdprc(:,:)
-      IF( nsolv == 2 )  gccd(:,:) = sor * gcp(:,:,2)
-
-      IF( nsolv == 2 .AND. MAX( jpr2di, jpr2dj ) > 0) THEN
+      IF( nn_solv == 2 )  gccd(:,:) = rn_sor * gcp(:,:,2)
+
+      IF( nn_solv == 2 .AND. MAX( jpr2di, jpr2dj ) > 0) THEN
          CALL lbc_lnk_e( gcp   (:,:,1), c_solver_pt, 1. )   ! lateral boundary conditions
          CALL lbc_lnk_e( gcp   (:,:,2), c_solver_pt, 1. )   ! lateral boundary conditions
@@ -308,90 +259,77 @@
       !!                the total area strictly above the pivot point,
       !!                and on the semi-row of the pivot point   
-      !!                
-      !! History :
-      !!   9.0  !  05-09  (R. Benshila)  original routine
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      CHARACTER(len=1) , INTENT( in ) ::   &
-         cd_type       ! define the nature of pt2d array grid-points
-         !             !  = T , U , V , F , W 
-         !             !  = S : T-point, north fold treatment
-         !             !  = G : F-point, north fold treatment
-         !             !  = I : sea-ice velocity at F-point with index shift
-      REAL(wp), DIMENSION(1-jpr2di:jpi+jpr2di,1-jpr2dj:jpj+jpr2dj,4), INTENT( inout ) ::   &
-         pt3d          ! 2D array on which the boundary condition is applied
-
-      !! * Local variables
-      INTEGER  ::   ji, jk      ! dummy loop indices
-      INTEGER  ::   iloc                ! temporary integers
-      REAL(wp), DIMENSION(1-jpr2di:jpi+jpr2di,1-jpr2dj:jpj+jpr2dj,4) ::   &
-         ztab          ! 2D array on which the boundary condition is applied
+      !!----------------------------------------------------------------------
+      CHARACTER(len=1) , INTENT( in ) ::   cd_type   ! define the nature of pt2d array grid-points
+         !                                           !  = T , U , V , F , W 
+         !                                           !  = S : T-point, north fold treatment
+         !                                           !  = G : F-point, north fold treatment
+         !                                           !  = I : sea-ice velocity at F-point with index shift
+      REAL(wp), DIMENSION(1-jpr2di:jpi+jpr2di,1-jpr2dj:jpj+jpr2dj,4), INTENT(inout) ::   pt3d   ! 2D field to be treated
+      !!
+      INTEGER  ::   ji, jk   ! dummy loop indices
+      INTEGER  ::   iloc     ! temporary integers
+      REAL(wp), DIMENSION(1-jpr2di:jpi+jpr2di,1-jpr2dj:jpj+jpr2dj,4) ::   ztab   ! 2D workspace
       !!----------------------------------------------------------------------
 
       ztab = pt3d
 
-      ! north fold treatment
-      ! -----------------------
-  
-      SELECT CASE ( npolj )
-         
-         CASE ( 3 , 4 )   !  T pivot
+      SELECT CASE ( npolj )            ! north fold type
+      ! 
+      CASE ( 3 , 4 )                        !==  T pivot  ==!
          iloc = jpiglo/2 +1 
-            
-            SELECT CASE ( cd_type )
-  
-            CASE ( 'T', 'S', 'U', 'W' )
-               DO jk =1, 4
-                  DO ji = 1-jpr2di, nlci+jpr2di
-                     pt3d(ji,nlcj:nlcj+jpr2dj,jk) = ztab(ji,nlcj:nlcj+jpr2dj,jk+3-2*MOD(jk+3,4))           
-                  ENDDO
-               ENDDO
-
-              DO jk =1, 4
-                  DO ji = nlci+jpr2di, 1-jpr2di,  -1
-                     IF( ( ji .LT. mi0(iloc) .AND. mi0(iloc) /= 1 ) &
-                       & .OR. ( mi0(iloc) == jpi+1 ) ) EXIT
+         !   
+         SELECT CASE ( cd_type )
+         ! 
+         CASE ( 'T', 'S', 'U', 'W' )
+            DO jk = 1, 4
+               DO ji = 1-jpr2di, nlci+jpr2di
+                  pt3d(ji,nlcj:nlcj+jpr2dj,jk) = ztab(ji,nlcj:nlcj+jpr2dj,jk+3-2*MOD(jk+3,4))           
+               END DO
+            END DO
+            DO jk =1, 4
+               DO ji = nlci+jpr2di, 1-jpr2di,  -1
+                  IF( ( ji .LT. mi0(iloc) .AND. mi0(iloc) /= 1 ) &
+                     & .OR. ( mi0(iloc) == jpi+1 ) ) EXIT
                      pt3d(ji,nlcj-1,jk) = ztab(ji,nlcj-1,jk+3-2*MOD(jk+3,4))
-                  ENDDO
-               ENDDO
-
-            CASE ( 'F' ,'G' , 'I', 'V' )
-               DO jk =1, 4
-                  DO ji = 1-jpr2di, nlci+jpr2di
-                     pt3d(ji,nlcj-1:nlcj+jpr2dj,jk) = ztab(ji,nlcj-1:nlcj+jpr2dj,jk+3-2*MOD(jk+3,4))           
-                  ENDDO
-               ENDDO
-
-            END SELECT   ! cd_type
-  
-         CASE ( 5 , 6 )                 ! F pivot
-          iloc=jpiglo/2
-
-            SELECT CASE (cd_type )
-
-            CASE ( 'T'  ,'S', 'U', 'W')
-               DO jk =1, 4
-                  DO ji = 1-jpr2di, nlci+jpr2di
-                     pt3d(ji,nlcj:nlcj+jpr2dj,jk) = ztab(ji,nlcj:nlcj+jpr2dj,jk+3-2*MOD(jk+3,4))           
-                  ENDDO
-               ENDDO
-
-            CASE ( 'F' ,'G' , 'I', 'V' )
-               DO jk =1, 4
-                  DO ji = 1-jpr2di, nlci+jpr2di
-                     pt3d(ji,nlcj:nlcj+jpr2dj,jk) = ztab(ji,nlcj:nlcj+jpr2dj,jk+3-2*MOD(jk+3,4))           
-                  ENDDO
-               ENDDO
-               DO jk =1, 4
-                  DO ji = nlci+jpr2di, 1-jpr2di,  -1
-                    IF ( ( ji .LT. mi0(iloc) .AND. mi0(iloc) /= 1 ) &
-                       & .OR. ( mi0(iloc) == jpi+1 ) ) EXIT
+               END DO
+            END DO
+            !
+         CASE ( 'F' ,'G' , 'I', 'V' )
+            DO jk =1, 4
+               DO ji = 1-jpr2di, nlci+jpr2di
+                  pt3d(ji,nlcj-1:nlcj+jpr2dj,jk) = ztab(ji,nlcj-1:nlcj+jpr2dj,jk+3-2*MOD(jk+3,4))           
+               END DO
+            END DO
+            !
+         END SELECT   ! cd_type
+          ! 
+      CASE ( 5 , 6 )                        !==  F pivot  ==!
+         iloc=jpiglo/2
+         !
+         SELECT CASE (cd_type )
+         !
+         CASE ( 'T'  ,'S', 'U', 'W')
+            DO jk =1, 4
+               DO ji = 1-jpr2di, nlci+jpr2di
+                  pt3d(ji,nlcj:nlcj+jpr2dj,jk) = ztab(ji,nlcj:nlcj+jpr2dj,jk+3-2*MOD(jk+3,4))           
+               END DO
+            END DO
+            !
+         CASE ( 'F' ,'G' , 'I', 'V' )
+            DO jk =1, 4
+               DO ji = 1-jpr2di, nlci+jpr2di
+                  pt3d(ji,nlcj:nlcj+jpr2dj,jk) = ztab(ji,nlcj:nlcj+jpr2dj,jk+3-2*MOD(jk+3,4))           
+               END DO
+            END DO
+            DO jk =1, 4
+               DO ji = nlci+jpr2di, 1-jpr2di,  -1
+                  IF( ( ji .LT. mi0(iloc) .AND. mi0(iloc) /= 1 ) .OR. ( mi0(iloc) == jpi+1 ) )   EXIT
                     pt3d(ji,nlcj-1,jk) = ztab(ji,nlcj-1,jk+3-2*MOD(jk+3,4))
-                  ENDDO
-               ENDDO
-
-            END SELECT   ! cd_type
-
-         END SELECT   ! npolj
+               END DO
+            END DO
+            !
+         END SELECT   ! cd_type
+         !
+      END SELECT   ! npolj
       !   
    END SUBROUTINE sol_exd
Index: trunk/NEMO/OPA_SRC/SOL/solpcg.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SOL/solpcg.F90	(revision 1598)
+++ trunk/NEMO/OPA_SRC/SOL/solpcg.F90	(revision 1601)
@@ -8,5 +8,4 @@
    !!   sol_pcg    : preconditionned conjugate gradient solver
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables 
@@ -19,14 +18,12 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC sol_pcg              ! ???
+   PUBLIC   sol_pcg    ! 
 
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
@@ -85,11 +82,9 @@
       !!        !  08-01  (R. Benshila) mpp optimization
       !!----------------------------------------------------------------------
-      !! * Arguments
       INTEGER, INTENT( inout ) ::   kindic   ! solver indicator, < 0 if the conver-
       !                                      ! gence is not reached: the model is
       !                                      ! stopped in step
       !                                      ! set to zero before the call of solpcg
-
-      !! * Local declarations
+      !!
       INTEGER ::   ji, jj, jn                ! dummy loop indices
       REAL(wp) ::  zgcad                     ! temporary scalars
@@ -151,5 +146,5 @@
         
       !                                                !================
-      DO jn = 1, nmax                                  ! Iterative loop
+      DO jn = 1, nn_nmax                               ! Iterative loop
          !                                             !================
 
@@ -177,5 +172,5 @@
 
          ! test of convergence
-         IF( rnorme < epsr .OR. jn == nmax ) THEN
+         IF( rnorme < epsr .OR. jn == nn_nmax ) THEN
             res = SQRT( rnorme )
             niter = jn
@@ -200,5 +195,5 @@
         
          ! indicator of non-convergence or explosion
-         IF( jn == nmax .OR. SQRT(epsr)/eps > 1.e+20 ) kindic = -2
+         IF( jn == nn_nmax .OR. SQRT(epsr)/eps > 1.e+20 ) kindic = -2
          IF( ncut == 999 ) GOTO 999
 
Index: trunk/NEMO/OPA_SRC/SOL/solsor.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SOL/solsor.F90	(revision 1598)
+++ trunk/NEMO/OPA_SRC/SOL/solsor.F90	(revision 1601)
@@ -4,9 +4,15 @@
    !! Ocean solver :  Successive Over-Relaxation solver
    !!=====================================================================
+   !! History :  OPA  ! 1990-10  (G. Madec)  Original code
+   !!            7.1  ! 1993-04  (G. Madec)  time filter
+   !!                 ! 1996-05  (G. Madec)  merge sor and pcg formulations
+   !!                 ! 1996-11  (A. Weaver)  correction to preconditioning
+   !!   NEMO     1.0  ! 2003-04  (C. Deltel, G. Madec)  Red-Black SOR in free form
+   !!            2.0  ! 2005-09  (R. Benshila, G. Madec)  MPI optimization
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
    !!   sol_sor     : Red-Black Successive Over-Relaxation solver
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables 
@@ -20,11 +26,10 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC sol_sor              ! ???
+   PUBLIC   sol_sor    ! 
 
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -49,41 +54,25 @@
       !!      conditions only when the inside domain is reached.
       !! 
-      !! References :
-      !!      Madec et al. 1988, Ocean Modelling, issue 78, 1-6.
-      !!      Beare and Stevens 1997 Ann. Geophysicae 15, 1369-1377
+      !! References :   Madec et al. 1988, Ocean Modelling, issue 78, 1-6.
+      !!                Beare and Stevens 1997 Ann. Geophysicae 15, 1369-1377
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(inout) ::   kindic   ! solver indicator, < 0 if the convergence is not reached:
+      !                                    ! the model is stopped in step (set to zero before the call of solsor)
       !!
-      !! History :
-      !!        !  90-10  (G. Madec)  Original code
-      !!        !  91-11  (G. Madec)
-      !!   7.1  !  93-04  (G. Madec)  time filter
-      !!        !  96-05  (G. Madec)  merge sor and pcg formulations
-      !!        !  96-11  (A. Weaver)  correction to preconditioning
-      !!   9.0  !  03-04  (C. Deltel, G. Madec)  Red-Black SOR in free form
-      !!   9.0  !  05-09  (R. Benshila, G. Madec)  MPI optimization
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( inout ) ::   kindic   ! solver indicator, < 0 if the conver-
-      !                                      ! gence is not reached: the model is
-      !                                      ! stopped in step
-      !                                      ! set to zero before the call of solsor
-      !! * Local declarations
       INTEGER  ::   ji, jj, jn               ! dummy loop indices
       INTEGER  ::   ishift, icount
+      INTEGER  ::   ijmppodd, ijmppeven, ijpr2d
       REAL(wp) ::   ztmp, zres, zres2
-
-      INTEGER  ::   ijmppodd, ijmppeven
-      INTEGER  ::   ijpr2d
       !!----------------------------------------------------------------------
       
-      ijmppeven = MOD(nimpp+njmpp+jpr2di+jpr2dj,2)
-      ijmppodd  = MOD(nimpp+njmpp+jpr2di+jpr2dj+1,2)
-      ijpr2d = MAX(jpr2di,jpr2dj)
+      ijmppeven = MOD( nimpp+njmpp+jpr2di+jpr2dj   , 2 )
+      ijmppodd  = MOD( nimpp+njmpp+jpr2di+jpr2dj+1 , 2 )
+      ijpr2d    = MAX( jpr2di , jpr2dj )
       icount = 0
       !                                                       ! ==============
-      DO jn = 1, nmax                                         ! Iterative loop 
+      DO jn = 1, nn_nmax                                      ! Iterative loop 
          !                                                    ! ==============
 
-         ! applied the lateral boundary conditions
-         IF( MOD(icount,ijpr2d+1) == 0 ) CALL lbc_lnk_e( gcx, c_solver_pt, 1. )   
+         IF( MOD(icount,ijpr2d+1) == 0 )   CALL lbc_lnk_e( gcx, c_solver_pt, 1. )   ! lateral boundary conditions
         
          ! Residus
@@ -103,11 +92,10 @@
                gcr(ji,jj) = zres * gcdmat(ji,jj) * zres
                ! Guess update
-               gcx(ji,jj) = sor * ztmp + (1-sor) * gcx(ji,jj)
+               gcx(ji,jj) = rn_sor * ztmp + (1-rn_sor) * gcx(ji,jj)
             END DO
          END DO
          icount = icount + 1 
  
-         ! applied the lateral boundary conditions
-         IF( MOD(icount,ijpr2d+1) == 0 ) CALL lbc_lnk_e( gcx, c_solver_pt, 1. )  
+         IF( MOD(icount,ijpr2d+1) == 0 )   CALL lbc_lnk_e( gcx, c_solver_pt, 1. )   ! lateral boundary conditions
 
          ! Guess red update
@@ -124,5 +112,5 @@
                gcr(ji,jj) = zres * gcdmat(ji,jj) * zres
                ! Guess update
-               gcx(ji,jj) = sor * ztmp + (1-sor) * gcx(ji,jj)
+               gcx(ji,jj) = rn_sor * ztmp + (1-rn_sor) * gcx(ji,jj)
             END DO
          END DO
@@ -130,12 +118,12 @@
 
          ! test of convergence
-         IF ( jn > nmin .AND. MOD( jn-nmin, nmod ) == 0 ) then
+         IF ( jn > nn_nmin .AND. MOD( jn-nn_nmin, nn_nmod ) == 0 ) THEN
 
-            SELECT CASE ( nsol_arp )
+            SELECT CASE ( nn_sol_arp )
             CASE ( 0 )                 ! absolute precision (maximum value of the residual)
                zres2 = MAXVAL( gcr(2:nlci-1,2:nlcj-1) )
                IF( lk_mpp )   CALL mpp_max( zres2 )   ! max over the global domain
                ! test of convergence
-               IF( zres2 < resmax .OR. jn == nmax ) THEN
+               IF( zres2 < rn_resmax .OR. jn == nn_nmax ) THEN
                   res = SQRT( zres2 )
                   niter = jn
@@ -146,5 +134,5 @@
                IF( lk_mpp )   CALL mpp_sum( rnorme )   ! sum over the global domain
                ! test of convergence
-               IF( rnorme < epsr .OR. jn == nmax ) THEN
+               IF( rnorme < epsr .OR. jn == nn_nmax ) THEN
                   res = SQRT( rnorme )
                   niter = jn
@@ -160,5 +148,5 @@
          ENDIF
          ! indicator of non-convergence or explosion
-         IF( jn == nmax .OR. SQRT(epsr)/eps > 1.e+20 ) kindic = -2
+         IF( jn == nn_nmax .OR. SQRT(epsr)/eps > 1.e+20 ) kindic = -2
          IF( ncut == 999 ) GOTO 999
          
@@ -169,11 +157,8 @@
 999   CONTINUE
       
-      
       !  Output in gcx
       !  -------------
-
       CALL lbc_lnk_e( gcx, c_solver_pt, 1. )    ! boundary conditions
-
-      
+      !
    END SUBROUTINE sol_sor
 
